//****************************************************************************
// @Module        Shared Interrupt Routines
// @Filename      SHARED_INT.C
// @Project       mcan.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC886CLM-8FF
//
// @Compiler      Keil
//
// @Codegenerator 1.1
//
// @Description   This file contains the Shared interrupt routines.
//
//----------------------------------------------------------------------------
// @Date          8/5/2006 10:20:52 AM
//
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "SHARED_INT.H"

// USER CODE BEGIN (SHARED_INT_General,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,7)

// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************


// USER CODE BEGIN (SHARED_INT_General,8)

// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,9)

// USER CODE END


//****************************************************************************
// @Function      void SHINT_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This function initializes the shared interrupts. 
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/5/2006
//
//****************************************************************************

// USER CODE BEGIN (SHINT_Init,1)

// USER CODE END

void SHINT_vInit(void)
{
  // USER CODE BEGIN (SHINT_Init,2)

  // USER CODE END

  ///  -----------------------------------------------------------------------
  ///  Configuration of the Shared  Interrupts:
  ///  -----------------------------------------------------------------------
  ///  - ADC Interrupt is Selected
  ///  - MultiCAN Node 7 Interrupt is Selected


  IEN1         |=  0x81;         // load interrupt enable register 1


  // USER CODE BEGIN (SHINT_Init,3)

  // USER CODE END


} //  End of function SHINT_vInit


//****************************************************************************
// @Function      void SHINT_viXINTR6Isr(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the service routine for the shared interrupt node 
//                XINTR6. XINTR6 ISR Node is shared by ADC[1:0] and MultiCAN 
//                Nodes 1 & 2. Depending on the selected module interrupt it 
//                is called. 
//                ADC -  It is activated by different interrupt sources 
//                (Channel Interrupts or Event Interrupts).The user obtains 
//                the conversion result by calling the function 
//                ADC_uwGetResultDataX(0,1,2,3).
//                CAN - It is called for the  Service Request Node 1 and 2 of 
//                the MultiCAN module.
//                Please note that you have to add application specific code 
//                to this function.
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/5/2006
//
//****************************************************************************

//   You have two choices for interrupt type select in Project Settings Page 
//   under Global Settings Section.
//   If you select CHOICE 1 then ISR will be generated with push and pop.
//   If you select CHOICE 2 then ISR will be generated without push and pop.
//   Default choice is CHOICE 2.
//   Current selection is CHOICE 2 

// USER CODE BEGIN (SHINT_XINTR6Isr,1)

// USER CODE END

void SHINT_viXINTR6Isr(void) interrupt XINTR6INT
{

  // USER CODE BEGIN (SHINT_XINTR6Isr,2)
  un_32bit adcResult_old; // Add this Line
  un_32bit adcResult_new; // Add this Line
  // USER CODE END

  SFR_PAGE(_su0, SST0);          // switch to page 0

  //   ADC interrupt handling section...

  //   Check Interrupt Request Register 1 Interrupt Flag 0 for ADC
  if (((IRCON1 & 0x08) != 0))
  {

    IRCON1 &= ~(ubyte)0x08; //   clear ADCSRC0

    // USER CODE BEGIN (SHINT_XINTR6Isr,3)
	// Get the ADC Result and transmit it thru CAN Node 1
	adcResult_new.ubDB[3] = ADC_uwGetResultData0() & 0xFF; // Add this Line
	if (adcResult_old.ubDB[3] != adcResult_new.ubDB[3]) { // Add this Line
	   CAN_vLoadData(0x1, &adcResult_new.ulVal); // Add this Line
	   CAN_vTransmit(0x1); // Add this Line
	   adcResult_old.ubDB[3] = adcResult_new.ubDB[3]; // Add this Line
	}
    // USER CODE END

  }


  //   Check Interrupt Request Register 1 Interrupt Flag 1 for ADC
  if (((IRCON1 & 0x10) != 0))
  {

    IRCON1 &= ~(ubyte)0x10; //   clear ADCSRC1

    // USER CODE BEGIN (SHINT_XINTR6Isr,4)

    // USER CODE END

  }


  // USER CODE BEGIN (SHINT_XINTR6Isr,7)

  // USER CODE END

  SFR_PAGE(_su0, RST0);          // restore the old SCU page
} //  End of function SHINT_viXINTR6Isr


//****************************************************************************
// @Function      void SHINT_viXINTR13Isr(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the service routine for the shared interrupt node 
//                XINTR13. XINTR13 ISR Node is shared by CCU6 Node Pointer 3 
//                and MultiCAN Node 7 . Depending on the selected module 
//                interrupt it is called. 
//                CCU6 - If the content of the corresponding compare timer 
//                (configurable) equals the content of the capture/compare 
//                register or if a capture event occurs at the associated 
//                port pin, the interrupt request flag is set and an 
//                interrupt is triggered (only if enabled).
//                CAN - It is called for the  Service Request Node 7 of the 
//                MultiCAN module.
//                Please note that you have to add application specific code 
//                to this function.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/5/2006
//
//****************************************************************************

//   You have two choices for interrupt type select in Project Settings Page 
//   under Global Settings Section.
//   If you select CHOICE 1 then ISR will be generated with push and pop.
//   If you select CHOICE 2 then ISR will be generated without push and pop.
//   Default choice is CHOICE 2.
//   Current selection is CHOICE 2 

// USER CODE BEGIN (NodeI3,1)

// USER CODE END

void SHINT_viXINTR13Isr(void) interrupt XINTR13INT
{

ubyte ubNSRL;
ubyte ubNSRH;
ubyte ubResetLEC = 0x3F;

ubyte ubTempMsgID = 0;
ubyte ubTempVarObjHandler = 0;
un_32bit ulBit_Pos_Mask;

  // USER CODE BEGIN (NodeI3,2)

  // USER CODE END

  CAN_pushAMRegs();              // push the CAN Access Mediator Registers

  SFR_PAGE(_su3, SST1);          // switch to page 3

  //   MultiCAN Node 7 (SRN7) interrupt handling section...

  //   Check Interrupt Request Register 4 Interrupt Flag 7
  if (((IRCON4 & 0x20) != 0))
  {

    IRCON4 &= ~(ubyte)0x20; //   clear CANSRC7

    //   ---------------------------------------------------------------------
    //   Interrupts of CAN node 1
    //   ---------------------------------------------------------------------

    CAN_vWriteCANAddress(CAN_NSR1);
    CAN_vReadEN();
    ubNSRL = CAN_DATA0;
    ubNSRH = CAN_DATA1;

    // USER CODE BEGIN (SRN7_NODE1,1)

    // USER CODE END
    //   ---------------------------------------------------------------------
    //   CAN node 1 Alert Interrupt
    //   ---------------------------------------------------------------------
    if (ubNSRL & 0x20)      // if ALERT
    {

          ///  Note: The ALERT bit is set upon the occurrence of one ofthe 
          ///  following events. User need to handle these in user defined 
          ///  section.

          // BOFF : ubNSRL & 0x80
                // Bus OFF
          // EWRN : ubNSRL & 0x40
                // One of the error counters REC or TEC reached the
                // warning limit of 96.
          // LLE : ubNSRH & 0x01
                // A list length error has been detected during message
                // acceptance filtering. The number of elements in the list
                // that belongs to this CAN node differs from the list SIZE 
                // given in the list termination pointer
          // LOE : ubNSRH & 0x02
                // A list object error has been detected during message
                // acceptance filtering. A message object with wrong LIST 
                // index entry in the Message Object Control Register has 
                // been detected

      // USER CODE BEGIN (SRN7_NODE_1_ALIE,2)

      // USER CODE END
    }

    //   ---------------------------------------------------------------------
    //   CAN node 1 Last Error Code
    //   ---------------------------------------------------------------------
    if (ubNSRL & 0x07)  // if LEC
    {
          ///  Note: a CAN protocol error with a last error code, details of 
          ///  bit field are mentioned below. User need to handle these in 
          ///  user defined section.

          // Stuff Error: (ubNSRL & 0x07) == 1
            ///  More than 5 equal bits in a sequence have occurredin a part 
            ///  of a received message where this is not allowed.

          // Form Error: (ubNSRL & 0x07) == 2
            ///  A fixed format part of a received frame has the wrong format.

          // Ack Error: (ubNSRL & 0x07) == 3
            ///  The message this CAN controller transmitted wasnot 
            ///  acknowledged by another node.

          // Bit1 Error: (ubNSRL & 0x07) == 4
            ///  During the transmission of a message (with the exeption of 
            ///  the arbitration field), the device wanted to send a 
            ///  recessive level ("1"), but the monitored bus value was 
            ///  dominant.

          // Bit0 Error: (ubNSRL & 0x07) == 5
            ///  During the transmission of a message (or acknow- ledge bit, 
            ///  active error flag, or overload flag), the device wanted to 
            ///  send a dominant level ("0"), but the monitored bus value was 
            ///  recessive.

            ///  During busoff recovery this status is set each time  a 
            ///  sequence of 11 recessive bits has been monitored. The CPU 
            ///  may use this code as indication that the  bus is not 
            ///  continuously disturbed).

          // CRC Error: (ubNSRL & 0x07) == 6
            ///  The CRC check sum was incorrect in the message received.

      ubResetLEC = 0x38;

      // USER CODE BEGIN (SRN7_NODE1_LEC,7)

      // USER CODE END
    }

    // USER CODE BEGIN (SRN7_NODE1,8)

    // USER CODE END

    //// Reset LEC, TXOK, RXOK, ALERT, EWRN, BOFF, LLE, LOE (if set)

    CAN_vWriteCANAddress(CAN_NSR1); // Addressing CAN_NSR1
    CAN_DATA0   =  ~(ubNSRL & ubResetLEC);       // load CAN_NSR1 status register[7-0]
    CAN_DATA1   =  ~(ubNSRH);       // load CAN_NSR1 status register[15-8]
    CAN_vWriteEN(D0_VALID+D1_VALID);  // Data0 and Data1 are Valid for
                                 // transmission and Write is Enabled.

    //   ---------------------------------------------------------------------
    //   Interrupts of CAN Msg Obj x 
    //   ---------------------------------------------------------------------

    CAN_vWriteCANAddress(CAN_MSIMASK);    // set message index mask register
    CAN_DATA0   =   0x00;        // set message index mask register
    CAN_DATA1   =   0x00;        // set message index mask register
    CAN_DATA2   =   0x01;        // set message index mask register
    CAN_DATA3   =   0x00;        // set message index mask register

    CAN_vWriteEN(ALL_DATA_VALID); // Write mode Enabled

    // USER CODE BEGIN (SRN7,1)

    // USER CODE END
    CAN_vWriteCANAddress(CAN_MSID0);   // message index register
    CAN_vReadEN();               // Read Mode is enabled

    ubTempMsgID = CAN_DATA0;

    if(ubTempMsgID != 0x20)
    {
      do
      {
      CAN_vWriteCANAddress(CAN_MOCTR(ubTempMsgID)); // Addressing CAN_MOCTRn
      CAN_vReadEN();               // Read Mode is enabled
      ubTempVarObjHandler = CAN_DATA0;

      ulBit_Pos_Mask.ulVal = ((unsigned long) 1 << ubTempMsgID);
      CAN_vWriteCANAddress(CAN_MSPND0); // Addressing CAN_MSPND0

      CAN_DATA0 = ~ulBit_Pos_Mask.ubDB[3]; // clear message pending register
      CAN_DATA1 = ~ulBit_Pos_Mask.ubDB[2]; // clear message pending register
      CAN_DATA2 = ~ulBit_Pos_Mask.ubDB[1]; // clear message pending register
      CAN_DATA3 = ~ulBit_Pos_Mask.ubDB[0]; // clear message pending register
      CAN_vWriteEN(ALL_DATA_VALID);  // Write mode Enabled

          ///  Note: Below commented code could be copied by the user to user 
          ///  defined section for Interrupt handling.

          ///  Handling of MO RXPND for receive data/remote frames (Generic 
          ///  Code).
          ///  (ubTempVarObjHandle & MOSTAT_RXPND)

          // if( ubTempVarObjHandler & MOSTAT_RXPND)   // if RXPND is set
          // {
          //
          //   if( ubTempVarObjHandler & MOSTAT_NEWDAT)   // if NEWDAT is set
          //   {
          //
          //     if( ubTempVarObjHandler & MOSTAT_MSGLST)  // if MSGLST is set
          //     {
          //// Indicates that the CAN controller has stored a new message into this object,
          //// while NEWDAT was still set, ie. the previously stored message is lost.
          //
          //      }
          //     else
          //     {
          //// The CAN controller has stored a new message into this object.
          //
          //      }
          //
          //    }
          //
          //// Reset RXPND, NEWDAT, MSGLST (if set)
          //
          //  CAN_vWriteCANAddress(CAN_MOCTR(ubTempMsgID)); // Addressing CAN_MOCTRn
          //
          //  CAN_DATA0 = (ubTempVarObjHandler & MOSTAT_RST_MNR); // load CAN Data Register 0
          //  CAN_DATA1 = 0x00; // load CAN Data Register 1
          //  CAN_DATA2 = 0x00; // load CAN Data Register 2
          //  CAN_DATA3 = 0x00; // load CAN Data Register 3
          //  CAN_vWriteEN(ALL_DATA_VALID);   // Writemode is Enabled
          // }  // End of RXPNDn

      // USER CODE BEGIN (SRN7_OBJ,1)
           if( ubTempVarObjHandler & MOSTAT_RXPND)   // if RXPND is set
           {
          
             if( ubTempVarObjHandler & MOSTAT_NEWDAT)   // if NEWDAT is set
             {
          
               if( ubTempVarObjHandler & MOSTAT_MSGLST)  // if MSGLST is set
               {
          // Indicates that the CAN controller has stored a new message into this object,
          // while NEWDAT was still set, ie. the previously stored message is lost.
          
                }
               else
               {
          // The CAN controller has stored a new message into this object.
		         CAN_vWriteCANAddress(CAN_MODATAL(ubTempMsgID));  // Add this line
		         CAN_vReadEN();									  // Add this line
		         IO_vWritePort(P3, CAN_DATA0);					  // Add this line
                }
          
              }
          
          // Reset RXPND, NEWDAT, MSGLST (if set)
          
            CAN_vWriteCANAddress(CAN_MOCTR(ubTempMsgID)); // Addressing CAN_MOCTRn
          
            CAN_DATA0 = (ubTempVarObjHandler & MOSTAT_RST_MNR); // load CAN Data Register 0
            CAN_DATA1 = 0x00; // load CAN Data Register 1
            CAN_DATA2 = 0x00; // load CAN Data Register 2
            CAN_DATA3 = 0x00; // load CAN Data Register 3
            CAN_vWriteEN(ALL_DATA_VALID);   // Writemode is Enabled
           }  // End of RXPNDn

      // USER CODE END

      CAN_vWriteCANAddress(CAN_MSIMASK);    // set message index mask register
      CAN_DATA0  =   0x00;       // set message index mask register
      CAN_DATA1  =   0x00;       // set message index mask register
      CAN_DATA2  =   0x01;       // set message index mask register
      CAN_DATA3  =   0x00;       // set message index mask register

      CAN_vWriteEN(ALL_DATA_VALID); // Write mode Enabled

      // USER CODE BEGIN (SRN7,5)

      // USER CODE END

      CAN_vWriteCANAddress(CAN_MSID0);   // message index register
      CAN_vReadEN();               // Read Mode is enabled
      ubTempMsgID = CAN_DATA0;

      }while (ubTempMsgID != 0x20); // end while

    }  // end if

    // USER CODE BEGIN (SRN7 ,4)

    // USER CODE END

  }

  // USER CODE BEGIN (NodeI3,5)

  // USER CODE END

  SFR_PAGE(_su3, RST1);          // restore the old SCU page

  CAN_popAMRegs();               // restore the CAN Access Mediator Registers
} //  End of function SHINT_viXINTR13Isr

// USER CODE BEGIN (SHARED_INT_General,10)

// USER CODE END


